from requests import Session
from requests.auth import HTTPBasicAuth  # or HTTPDigestAuth, or OAuth1, etc.
from zeep import Client
from zeep.transports import Transport
import xmltodict
import xml.etree.ElementTree as ET
import mysql.connector
import uuid
import datetime
from cryptography.fernet import Fernet
import json
import time
import getopt, sys
import datetime
from datetime import timedelta

mydb = mysql.connector.connect(host="localhost", user="Canopus", password="care")

mycursor = mydb.cursor()


mycursor.execute("use care_new")

key = b"pRmgMa8T0INjEAfksaq2aafzoZXEuwKI7wDe4c1F8AY="

cipher_suite = Fernet(key)

wsdl = []


def instWSDL(instance_id):
    command="SELECT system_id,customer_id,instancewsdlurl,insuniqueid,features,appuid,apppassword,sysname from instancelist where status = 1 and instanceno != 100 and insuniqueid = '" + instance_id + "';"
    mycursor.execute(command)
    i = mycursor.fetchall()
    instwsdl = []
    wsdlarray = dict()
    # print(myresult)
    command1 = (
        "SELECT solution_id,ostype,sid,dbtype from systems_v2 where sysuniqueid='"
        + i[0][0]
        + "';"
    )
    mycursor.execute(command1)
    myresult1 = mycursor.fetchall()
    # print(myresult1)
    pwd = cipher_suite.decrypt(str.encode(i[0][6]))
    fpwd = pwd.decode()
    wsdlarray = {
        "wsdl": i[0][2],
        "sid": i[0][5],
        "pwd": fpwd,
        "ip": i[0][7],
        "system_id": i[0][0],
        "customer_id": i[0][1],
        "instance_id": i[0][3],
        "features": i[0][4],
        "solution_id": myresult1[0][0],
        "ostype": myresult1[0][1],
        "ssid": myresult1[0][2],
        "dbtype": myresult1[0][3]
    }
    return wsdlarray


def Connection(wsdl, adm, pwd):
    session = Session()
    session.auth = HTTPBasicAuth(adm, pwd)
    session.verify = True
    transport = Transport(session=session)
    client = Client(wsdl=wsdl, transport=transport)

    return client


def currentalerts(i1):
    client = Connection(i1["wsdl"], i1["sid"], i1["pwd"])
    a = client.service.GetAlertTree()
    for i in a:
        if i["parent"] == -1:
            i["parent"] = ""

        if i["name"] == None:
            i["name"] = "None"

        if i["parent"] == None:
            i["parent"] = "None"

        if i["ActualValue"] == None:
            i["ActualValue"] = "None"

        if i["description"] == None:
            i["description"] = "None"

        if i["Time"] == None:
            i["Time"] = "None"

        if i["AnalyseTool"] == None:
            i["AnalyseTool"] = "None"

        if i["VisibleLevel"] == None:
            i["VisibleLevel"] = "None"

        if i["HighAlertValue"] == None:
            i["HighAlertValue"] = "None"

        if i["AlDescription"] == None:
            i["AlDescription"] = "None"

        if i["AlTime"] == None:
            i["AlTime"] = "None"

        if i["Tid"] == None:
            i["Tid"] = "None"

    new_a = []
    dictionary = {}
    for i in a:
        dictionary = {}
        dictionary["name"] = i["name"]
        dictionary["parent"] = i["parent"]
        dictionary["ActualValue"] = i["ActualValue"]
        dictionary["description"] = i["description"]
        dictionary["Time"] = i["Time"]
        dictionary["AnalyseTool"] = i["AnalyseTool"]
        dictionary["VisibleLevel"] = i["VisibleLevel"]
        dictionary["HighAlertValue"] = i["HighAlertValue"]
        dictionary["AlDescription"] = i["AlDescription"]
        dictionary["AlTime"] = i["AlTime"]
        dictionary["Tid"] = i["Tid"]
        new_a.append(dictionary)

    tree = []
    list_ind = []
    for i in new_a:
        ind = new_a.index(i)
        i["Id"] = ind
        list_ind.append(i)

    mappedarr = {}
    for i in list_ind:
        Id = i["Id"]
        if Id not in mappedarr.keys():
            mappedarr[Id] = i
            mappedarr[Id]["children"] = []

    for i in mappedarr.keys():
        mappedelement = mappedarr[i]

        if mappedelement["parent"]:
            parentid = mappedelement["parent"]
            (mappedarr[parentid]["children"]).append(mappedelement)

        else:
            tree.append(mappedelement)

    json_res = json.dumps(tree[1], indent=4)
    sql = "INSERT INTO alerttree(treeuniqueid,customer_id,system_id,tree,created_at) VALUES(%s, %s,%s, %s,%s)"
    treeuniqueid = uuid.uuid4()
    created_at = datetime.datetime.now()
    value = (treeuniqueid.hex, i1["customer_id"], i1["system_id"], json_res, created_at)
    mycursor.execute(sql, value)
    mydb.commit()
    # mycursor.close()


def getprocesslist(i):
    try:
        client = Connection(i["wsdl"], i["sid"], i["pwd"])
        a = client.service.GetProcessList()
        sql = "INSERT INTO process_list(processuniqueid,system_id,customer_id,pname,pdesc,dispstatus,stime,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s, %s, %s)"
        created_at = datetime.datetime.now()
        if a != None:
            for j in a:
                name = j["name"]
                description = j["description"]
                dispstatus = j["dispstatus"]
                starttime = j["starttime"]
                if starttime is None:
                    time = 0
                else:
                    k = starttime.split()
                    l1 = k[0:-1]
                    s = "-"
                    s = s.join(l1)
                    time = s + " " + k[-1]

                processuniqueid = uuid.uuid4()

                value = (
                    processuniqueid.hex,
                    i["system_id"],
                    i["customer_id"],
                    name,
                    description,
                    dispstatus,
                    time,
                    created_at,
                    i["instance_id"],
                )
                mycursor.execute(sql, value)
                mydb.commit()
    except:
        print("Error")
def sla(i):
    sysid = i["system_id"]
    cusid = i["customer_id"]
    insid = i["instance_id"]
    solid = i["solution_id"]
    primaryidcmd = "SELECT max(id) from sla where instance_id = '" + insid + "';"

    mycursor.execute(primaryidcmd)
    myresult = mycursor.fetchall()
    pkey = myresult[0][0]

    countcmd = "SELECT * from sla where id = '" + str(pkey) + "';"
    mycursor.execute(countcmd)
    myresult1 = mycursor.fetchall()
    count = myresult1[0][8]
    created_at = myresult1[0][11]
    modified_at = datetime.datetime.now()

    slastatus = myresult1[0][4]
    stime = myresult1[0][5]
    etime = myresult1[0][6]
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.ReadDeveloperTrace(filename="available.log", size=0)
    available_log_list = a["lines"]["item"]
    if len(available_log_list) == count:

        slauniqueid = uuid.uuid4()
        sql = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,created_at,count,instance_id,solution_id,modified_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
        value = (
            slauniqueid.hex,
            cusid,
            sysid,
            slastatus,
            etime,
            modified_at,
            created_at,
            count,
            insid,
            solid,
            modified_at,
        )
        # print("No Change")
        # print(value)
        mycursor.execute(sql, value)
        mydb.commit()
    elif len(available_log_list) > count:
        slauniqueid = uuid.uuid4()
        log = a["lines"]["item"][count - 1]
        temp_log_list = log.split()
        temp_etime = temp_log_list[-2] + " " + temp_log_list[-1]
        sql = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,created_at,count,instance_id,solution_id,modified_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
        value = (
            slauniqueid.hex,
            cusid,
            sysid,
            slastatus,
            etime,
            temp_etime,
            created_at,
            count,
            insid,
            solid,
            modified_at,
        )
        # print("Change 1st entry")
        # print(value)
        mycursor.execute(sql, value)
        mydb.commit()
        for i in a["lines"]["item"][count:]:
            uid = uuid.uuid4()
            temp_lodg_list_1 = i.split()
            stime1 = temp_lodg_list_1[1] + " " + temp_lodg_list_1[2]
            etime1 = temp_lodg_list_1[-2] + " " + temp_lodg_list_1[-1]
            count1 = (a["lines"]["item"]).index(i)
            sql1 = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,created_at,count,instance_id,solution_id,modified_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
            value1 = (
                uid.hex,
                cusid,
                sysid,
                temp_lodg_list_1[0],
                stime1,
                etime1,
                created_at,
                count1 + 1,
                insid,
                solid,
                modified_at,
            )
            # print("Change rest of the entries")
            # print(value1)
            mycursor.execute(sql1, value1)
            mydb.commit()


def onetimesla(i):
    sysid = i["system_id"]
    cusid = i["customer_id"]
    insid = i["instance_id"]
    solid = i["solution_id"]
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.ReadDeveloperTrace(filename="available.log", size=0)
    created_at = datetime.datetime.now()
    for i in a["lines"]["item"]:
        uid = uuid.uuid4()
        l = i.split()
        stime = l[1] + " " + l[2]
        etime = l[-2] + " " + l[-1]
        sql = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,modified_at,count,instance_id,solution_id,created_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
        count = ((a["lines"]["item"]).index(i)) + 1
        value = (
            uid.hex,
            cusid,
            sysid,
            l[0],
            stime,
            etime,
            created_at,
            count,
            insid,
            solid,
            created_at,
        )
        mycursor.execute(sql, value)
        mydb.commit()


def heartbeat(i1):
    client = Connection(i1["wsdl"], i1["sid"], i1["pwd"])
    up = 0
    down = 0
    partially = 0
    status = 1
    currentalerts = client.service.GetAlertTree()
    if len(currentalerts) > 0:
        a = client.service.GetSystemInstanceList()
        for i in a:
            if i["dispstatus"] == "SAPControl-GREEN":
                up = up + 1
            elif i["dispstatus"] == "SAPControl-YELLOW":
                partially = partially + 1

            elif i["dispstatus"] == "SAPControl-GRAY":
                down = down + 1
        if (partially == 0) and (up == 0):
            status = 0
        elif (down == 0) and (partially == 0):
            status = 1
        else:
            status = 2
        modified_at = datetime.datetime.now()
        sql = "UPDATE systems_v2 SET modified_at=%s,status=%s  WHERE sysuniqueid=%s"
        value = (modified_at, status, i1["system_id"])
        mycursor.execute(sql, value)
        mydb.commit()


def instanceheartbeat(i1):
    status = 0
    client = Connection(i1["wsdl"], i1["sid"], i1["pwd"])
    portsql = (
        "select http_port from instancelist where insuniqueid ='"
        + i1["instance_id"]
        + "';"
    )
    mycursor.execute(portsql)
    myresult = mycursor.fetchall()
    currentalerts = client.service.GetAlertTree()
    if len(currentalerts) > 0:
        a = client.service.GetSystemInstanceList()
        for i in a:
            if i["httpPort"] == myresult[0][0]:
                if i["dispstatus"] == "SAPControl-GREEN":
                    status = 1
                elif i["dispstatus"] == "SAPControl-YELLOW":
                    status = 2
                elif i["dispstatus"] == "SAPControl-GRAY":
                    status = 0
        created_at = datetime.datetime.now()
        sql = "UPDATE instancelist SET created_at=%s,status=%s  WHERE insuniqueid=%s"
        value = (created_at, status, i1["instance_id"])
        mycursor.execute(sql, value)
        mydb.commit()


def currentalerts_generic(i1):
    list_trees = []
    #print(i1)
    client = Connection(i1['wsdl'], i1['sid'], i1['pwd'])
    a = client.service.GetAlertTree()
    for i in a:
        if i['parent'] == -1:
            i['parent'] = ''

        if i['name'] == None:
            i['name'] = 'None'

        if i['parent'] == None:
            i['parent'] = 'None'

        if i['description'] == None:
            i['description'] = 'None'
    new_a = []
    dictionary = {}
    for i in a:
        dictionary = {}
        dictionary['name'] = i['name']
        dictionary['parent'] = i['parent']
        dictionary['description'] = i['description']

        new_a.append(dictionary)
    tree = []
    list_ind = []
    for i in new_a:
        ind = new_a.index(i)
        i['Id'] = ind
        list_ind.append(i)

    mappedarr = {}
    for i in list_ind:
        Id = i['Id']
        if Id not in mappedarr.keys():
            mappedarr[Id] = i
            mappedarr[Id]['children'] = []

    for i in mappedarr.keys():
        mappedelement = mappedarr[i]

        if mappedelement['parent']:
            parentid = mappedelement['parent']
            mappedarr[parentid]['children'].append(mappedelement)
        else:

            tree.append(mappedelement)
    tree.append(i1)
    return tree
def fs(i1):
    for i in i1[1]["children"]:
        if i["name"] == "Filesystems":
            created_at = datetime.datetime.now()
            for j in i["children"]:
                fsuniqueid = uuid.uuid4()
                obj = []
                for k in j["children"]:
                    obj.append(k["description"])
                sql = "INSERT INTO fsmonitoring(fsmonitoringuniqueid,customer_id,system_id,filesys,free,perc,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s,%s)"
                value = (
                    fsuniqueid.hex,
                    i1[-1]["customer_id"],
                    i1[-1]["system_id"],
                    obj[0],
                    obj[1],
                    obj[2],
                    created_at,
                    i1[-1]["instance_id"],
                )
                mycursor.execute(sql, value)
                mydb.commit()


def cpu(i1):
    for i in i1[1]["children"]:
        if i["name"] == "CPU":
            created_at = datetime.datetime.now()
            for j in i["children"]:
                metric = j["name"]
                value = j["description"]
                cpuuniqueid = uuid.uuid4()
                sql = "INSERT INTO cpumonitoring(cpumonitoringuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s)"
                insert_value = (
                    cpuuniqueid.hex,
                    i1[-1]["customer_id"],
                    i1[-1]["system_id"],
                    metric,
                    value,
                    created_at,
                    i1[-1]["instance_id"],
                )
                mycursor.execute(sql, insert_value)
                mydb.commit()


def mem(i1):
    for i in i1[1]["children"]:
        if i["name"] == "Memory":
            created_at = datetime.datetime.now()
            for j in i["children"]:
                metric = j["name"]
                value = j["description"]
                memuniqueid = uuid.uuid4()
                sql = "INSERT INTO memorymonitoring(memorymonitoringuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s)"
                insert_value = (
                    memuniqueid.hex,
                    i1[-1]["customer_id"],
                    i1[-1]["system_id"],
                    metric,
                    value,
                    created_at,
                    i1[-1]["instance_id"],
                )
                mycursor.execute(sql, insert_value)
                mydb.commit()


def workprocess(i1):
    client = Connection(i1["wsdl"], i1["sid"], i1["pwd"])
    a = client.service.ABAPGetSystemWPTable()
    created_at = datetime.datetime.now()
    for i in a:
        wpuniqueid = uuid.uuid4()
        Instance = i["Instance"]
        No = i["No"]
        Typ = i["Typ"]
        Status = i["Status"]
        Reason = i["Reason"]
        Start = i["Start"]
        Err = i["Err"]
        Sem = i["Sem"]
        Cpu = i["Cpu"]
        Time = i["Time"]
        Program = i["Program"]
        Client = i["Client"]
        User = i["User"]
        Action = i["Action"]
        Table = i["Table"]
        sql = "INSERT INTO workprocessmonitoring(wpuniqueid,customer_id,system_id,Instance,No,Typ,Status,Reason,Start,Err,sem,cpu,wptime,program,client,user,action,wptable,created_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s, %s,%s, %s,%s, %s,%s,%s, %s,%s, %s,%s)"
        value = (
            wpuniqueid.hex,
            i1["customer_id"],
            i1["system_id"],
            Instance,
            No,
            Typ,
            Status,
            Reason,
            Start,
            Err,
            Sem,
            Cpu,
            Time,
            Program,
            Client,
            User,
            Action,
            Table,
            created_at,
        )
        mycursor.execute(sql, value)
        mydb.commit()


def runtimedumps(i1):
    created_at = datetime.datetime.now()
    for i in i1[5]["children"]:
        dumpsuniqueid = uuid.uuid4()
        metric = i["name"]
        value = i["description"]
        sql = "INSERT INTO runtimedumps(dumpsuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s)"
        sql_value = (
            dumpsuniqueid.hex,
            i1[-1]["customer_id"],
            i1[-1]["system_id"],
            metric,
            value,
            created_at,
            i1[-1]["instance_id"],
        )
        mycursor.execute(sql, sql_value)
        mydb.commit()


def responsetime(i1):
    created_at = datetime.datetime.now()
    for i in i1[3]["children"]:
        if i["name"] == "Dialog":
            for j in i["children"]:
                responsetimeuniqueid = uuid.uuid4()
                metric = j["name"]
                value = j["description"]
                sql = "INSERT INTO responsetimes(resuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s)"
                sql_value = (
                    responsetimeuniqueid.hex,
                    i1[-1]["customer_id"],
                    i1[-1]["system_id"],
                    metric,
                    value,
                    created_at,
                    i1[-1]["instance_id"],
                )
                mycursor.execute(sql, sql_value)
                mydb.commit()


def update(i1):
    created_at = datetime.datetime.now()
    for i in i1[3]["children"]:
        if i["name"] == "Update":
            for j in i["children"]:
                updatetype = j["name"]
                for k in j["children"]:
                    updateuniqueid = uuid.uuid4()
                    metric = k["name"]
                    value = k["description"]
                    sql = "INSERT INTO updatemonitoring(updateuniqueid,customer_id,system_id,updatetype,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
                    sql_value = (
                        updateuniqueid.hex,
                        i1[-1]["customer_id"],
                        i1[-1]["system_id"],
                        updatetype,
                        metric,
                        value,
                        created_at,
                        i1[-1]["instance_id"],
                    )
                    mycursor.execute(sql, sql_value)
                    mydb.commit()


def buffer(i1):
    try:
        created_at = datetime.datetime.now()
        buffer_found = True;
        for i in i1[4]["children"]:
            if i["name"] == "Buffers":
                buffer_found = False
                for j in i["children"]:
                    buffertype = j["name"]
                    for k in j["children"]:
                        bufferuniqueid = uuid.uuid4()
                        metric = k["name"]
                        value = k["description"]
                        sql = "INSERT INTO buffer(bufferuniqueid,customer_id,system_id,buffertype,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
                        sql_value = (
                            bufferuniqueid.hex,
                            i1[-1]["customer_id"],
                            i1[-1]["system_id"],
                            buffertype,
                            metric,
                            value,
                            created_at,
                            i1[-1]["instance_id"],
                        )
                        mycursor.execute(sql, sql_value)
                        mydb.commit()
        if buffer_found:
                sql = "INSERT INTO buffer(bufferuniqueid,customer_id,system_id,buffertype,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
                bufferuniqueid = uuid.uuid4()
                sql_value = (
                            bufferuniqueid.hex,
                            i1[-1]["customer_id"],
                            i1[-1]["system_id"],
                            "Buffers",
                            "Error: Unable to get buffers",
                            "No child found in GetAlertTree with Buffers name",
                            created_at,
                            i1[-1]["instance_id"],
                        )
                mycursor.execute(sql, sql_value)
                mydb.commit()

    except Exception as e:
        print(e)


def enquelocks(i1):
    client = Connection(i1["wsdl"], i1["sid"], i1["pwd"])
    with client.settings(raw_response=True):

        a = client.service.EnqGetLockTable()
        # print(etree.tostring(a.content.decode('utf-8'), encoding="unicode", pretty_print=True))
        # print(a.content.decode('utf-8').replace("￿",''))
        # tree = ET.ElementTree(ET.fromstring(a.content.decode('utf-8')))
        # print(tree)
        # print(type(tree))
        created_at = datetime.datetime.now()
        a_dict = xmltodict.parse(
            a.content.decode("utf-8").replace("￿", "").replace("null", "")
        )
        # print(a_dict['SOAP-ENV:Envelope']['SOAP-ENV:Body'].keys())
        try:

            for i in a_dict["SOAP-ENV:Envelope"]["SOAP-ENV:Body"][
                "SAPControl:EnqGetLockTableResponse"
            ]["lock"]["item"]:

                lockname = i["lock-name"]
                # print(lockname)
                lockarg = i["lock-arg"]
                client = i["client"]
                user = i["user"]
                if i["owner-vb"] is not None:
                    obj = datetime.datetime.strptime(i["owner-vb"][0:20], '%Y%m%d%H%M%S%f')
                elif i["owner"] is not None:
                    obj = datetime.datetime.strptime(i["owner"][0:20], '%Y%m%d%H%M%S%f')
                else :
                    obj = created_at
                enquelocksuniqueid = uuid.uuid4()
                sql = "INSERT INTO enquelocksmonitoring(enquelocksuniqueid,customer_id,system_id,lockname,lockarg,client,user,object1,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s)"
                sql_value = (
                    enquelocksuniqueid.hex,
                    i1["customer_id"],
                    i1["system_id"],
                    lockname,
                    lockarg,
                    client,
                    user,
                    obj,
                    created_at,
                    i1["instance_id"],
                )
                # print(sql_value)
                mycursor.execute(sql, sql_value)
                mydb.commit()
        except KeyError:
            print("KeyError")


# except:
#     print("error")


def J2EEGetProcessList2(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetProcessList2()
    created_at = datetime.datetime.now()

    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetprocesslist2(name,pid,type,restart,exitCode,statetext,startTime,elapsedTime,restartCount,errorCount,cpu,debug,clusterId,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s, %s,%s,%s,%s,%s)"
        sql_value = (
            i_dict[0][1]["name"],
            i_dict[0][1]["pid"],
            i_dict[0][1]["type"],
            i_dict[0][1]["restart"],
            i_dict[0][1]["exitCode"],
            i_dict[0][1]["statetext"],
            i_dict[0][1]["startTime"],
            i_dict[0][1]["elapsedTime"],
            i_dict[0][1]["restartCount"],
            i_dict[0][1]["errorCount"],
            i_dict[0][1]["cpu"],
            i_dict[0][1]["debug"],
            i_dict[0][1]["clusterId"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        # print(sql_value)
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetThreadList2(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetThreadList2()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetthreadlist2(processname,startTime,taskupdateTime,subtaskupdateTime,task,subtask,name,classname,user,pool,state,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s, %s,%s,%s)"
        sql_value = (
            i_dict[0][1]["processname"],
            i_dict[0][1]["startTime"],
            i_dict[0][1]["taskupdateTime"],
            i_dict[0][1]["subtaskupdateTime"],
            i_dict[0][1]["task"],
            i_dict[0][1]["subtask"],
            i_dict[0][1]["name"],
            i_dict[0][1]["classname"],
            i_dict[0][1]["user"],
            i_dict[0][1]["pool"],
            i_dict[0][1]["state"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        # print(sql_value)
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetSessionList(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetSessionList()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetsessionlist(processname,IdHash,size,timeout,activeRequests,startTime,updateTime,sticky,corrupt,backingStore,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s,%s,%s)"
        sql_value = (
            i_dict[0][1]["processname"],
            i_dict[0][1]["IdHash"],
            i_dict[0][1]["size"],
            i_dict[0][1]["timeout"],
            i_dict[0][1]["activeRequests"],
            i_dict[0][1]["startTime"],
            i_dict[0][1]["updateTime"],
            i_dict[0][1]["sticky"],
            i_dict[0][1]["corrupt"],
            i_dict[0][1]["backingStore"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        # print(sql_value)
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetWebSessionList(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetWebSessionList()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetwebsessionlist(processname,IdHash,size,timeout,activeRequests,startTime,updateTime,state,user,backingStore,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s,%s,%s)"
        sql_value = (
            i_dict[0][1]["processname"],
            i_dict[0][1]["IdHash"],
            i_dict[0][1]["size"],
            i_dict[0][1]["timeout"],
            i_dict[0][1]["activeRequests"],
            i_dict[0][1]["startTime"],
            i_dict[0][1]["updateTime"],
            i_dict[0][1]["state"],
            i_dict[0][1]["user"],
            i_dict[0][1]["backingStore"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetCacheStatistic2(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetCacheStatistic2()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetcachestatistic2(description,owner,type,size,attrSize,keysSize,cachedObjects,usedObjects,puts,gets,hits,removes,changes,evictions,instanceInvalidations,clusterInvalidations,updateTime,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s, %s,%s, %s, %s, %s, %s, %s,%s,%s)"
        sql_value = (
            i_dict[0][1]["description"],
            i_dict[0][1]["owner"],
            i_dict[0][1]["type"],
            i_dict[0][1]["size"],
            i_dict[0][1]["attrSize"],
            i_dict[0][1]["keysSize"],
            i_dict[0][1]["cachedObjects"],
            i_dict[0][1]["usedObjects"],
            i_dict[0][1]["puts"],
            i_dict[0][1]["gets"],
            i_dict[0][1]["hits"],
            i_dict[0][1]["removes"],
            i_dict[0][1]["changes"],
            i_dict[0][1]["evictions"],
            i_dict[0][1]["instanceInvalidations"],
            i_dict[0][1]["clusterInvalidations"],
            i_dict[0][1]["updateTime"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetComponentList(i):
    try:
        client = Connection(i["wsdl"], i["sid"], i["pwd"])
        a = client.service.J2EEGetComponentList()
        created_at = datetime.datetime.now()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            sql = "INSERT INTO j2eegetcomponentlist(type,name,startupmode,status,expectedstatus,details,dispstatus,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s,%s,%s)"
            sql_value = (
                i_dict[0][1]["type"],
                i_dict[0][1]["name"],
                i_dict[0][1]["startupmode"],
                i_dict[0][1]["status"],
                i_dict[0][1]["expectedstatus"],
                i_dict[0][1]["details"],
                i_dict[0][1]["dispstatus"],
                i["system_id"],
                i["instance_id"],
                created_at,
                i["customer_id"],
            )
            mycursor.execute(sql, sql_value)
            mydb.commit()

    except Exception as err:
        print(err)


def J2EEGetVMHeapInfo(i):
    try:
        client = Connection(i["wsdl"], i["sid"], i["pwd"])
        a = client.service.J2EEGetVMHeapInfo()
        created_at = datetime.datetime.now()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            sql = "INSERT INTO j2eegetvmheapinfo(processname,type,size,commitSize,maxUsedSize,initialSize,maxSize,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s,%s,%s)"
            sql_value = (
                i_dict[0][1]["processname"],
                i_dict[0][1]["type"],
                i_dict[0][1]["size"],
                i_dict[0][1]["commitSize"],
                i_dict[0][1]["maxUsedSize"],
                i_dict[0][1]["initialSize"],
                i_dict[0][1]["maxSize"],
                i["system_id"],
                i["instance_id"],
                created_at,
                i["customer_id"],
            )
            # print(sql_value)
            mycursor.execute(sql, sql_value)
            mydb.commit()

    except Exception as err:
        print(err)


def J2EEGetVMGCHistory2(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetVMGCHistory2()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetvmgchistory2(processname,type,reason,startTime,duration,cpuTime,objBytesBefore,objBytesAfter,objBytesFreed,clsBytesBefore,clsBytesAfter,clsBytesFreed,heapSize,unloadedClasses,pageFaults,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s,%s, %s,%s, %s, %s, %s, %s,%s,%s)"
        sql_value = (
            i_dict[0][1]["processname"],
            i_dict[0][1]["type"],
            i_dict[0][1]["reason"],
            i_dict[0][1]["startTime"],
            i_dict[0][1]["duration"],
            i_dict[0][1]["cpuTime"],
            i_dict[0][1]["objBytesBefore"],
            i_dict[0][1]["objBytesAfter"],
            i_dict[0][1]["objBytesFreed"],
            i_dict[0][1]["clsBytesBefore"],
            i_dict[0][1]["clsBytesAfter"],
            i_dict[0][1]["clsBytesFreed"],
            i_dict[0][1]["heapSize"],
            i_dict[0][1]["unloadedClasses"],
            i_dict[0][1]["pageFaults"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetSharedTableInfo(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetSharedTableInfo()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        sql = "INSERT INTO j2eegetsharedtableinfo(table_info,used,peak,limit_info,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s,%s,%s)"
        sql_value = (
            i_dict[0][1]["table"],
            i_dict[0][1]["used"],
            i_dict[0][1]["peak"],
            i_dict[0][1]["limit"],
            i["system_id"],
            i["instance_id"],
            created_at,
            i["customer_id"],
        )
        mycursor.execute(sql, sql_value)
        mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetClusterMsgList(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetClusterMsgList()
    created_at = datetime.datetime.now()
    # print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        for key in i_dict[0][1].keys():
            if not key in ["dispstatus"]:
                result_dict[key] = i_dict[0][1][key]
                # sql = "INSERT INTO j2eegetclustermsglist() VALUES()"
                # sql_value = ()
                # # print(sql_value)
                # mycursor.execute(sql,sql_value)
                # mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetThreadCallStack(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetThreadCallStack()
    created_at = datetime.datetime.now()
    print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        for key in i_dict[0][1].keys():
            if not key in ["dispstatus"]:
                result_dict[key] = i_dict[0][1][key]
                # sql = "INSERT INTO j2eegetthreadcallstack() VALUES()"
                # sql_value = ()
                # # print(sql_value)
                # mycursor.execute(sql,sql_value)
                # mydb.commit()


# except Exception as err:
#     print(err)


def J2EEGetThreadTaskStack(i):
    # try:
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    a = client.service.J2EEGetThreadTaskStack()
    created_at = datetime.datetime.now()
    print(a)
    for j in a:
        result_dict = {}
        i_dict = list(j.__dict__.items())
        for key in i_dict[0][1].keys():
            if not key in ["dispstatus"]:
                result_dict[key] = i_dict[0][1][key]
                # sql = "INSERT INTO j2eegetthreadtaskstack() VALUES()"
                # sql_value = ()
                # # print(sql_value)
                # mycursor.execute(sql,sql_value)
                # mydb.commit()
def R3trans_check(i):
    client = Connection(i["wsdl"], i["sid"], i["pwd"])
    created_at = datetime.datetime.now()
    db_insstatus = 0
    if i["ostype"] == 'Linux':
        r3Trans_output = client.service.OSExecute(command = "/usr/sap/"+i["ssid"].upper()+"/SYS/exe/run/R3trans -x",**{'async':0},timeout=30)
        if r3Trans_output['exitcode'] == 0:
            return_code = r3Trans_output['lines']['item'][2]
            return_code = return_code[return_code.find("(")+1:return_code.find(")")]
            if(return_code == '0000'):
                db_insstatus = 1
    elif i["ostype"] == 'Microsoft_Windows_Server':
        r3Trans_output = client.service.OSExecute(command = "R3trans -x",**{'async':0},timeout=30)
        if r3Trans_output['exitcode'] == 0:
            return_code = r3Trans_output['lines']['item'][2]
            return_code = return_code[return_code.find("(")+1:return_code.find(")")]
            if(return_code == '0000'):
                db_insstatus = 1
    sql = "INSERT INTO r3translogs(system_id,customer_id,instance_id,metric,value,created_at) VALUES(%s, %s,%s, %s,%s, %s)"
    sql_value = (
        i["system_id"],
        i["customer_id"],
        i["instance_id"],
        "R3trans",
        db_insstatus,
        created_at,
        )
    mycursor.execute(sql, sql_value)
    mydb.commit()
#def sapjobs(system_id,customer_id,email,wsdl,log_id,created_at):
def sapjobs(i):
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        sysid = i["system_id"]
        cusid = i["customer_id"]
        sub_by = "auto_monitoring"
        sid = i["ssid"]
        log_id = uuid.uuid4().hex
        created_at = datetime.datetime.now()
        try:
            a = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""SELECT JOBNAME,BTCSYSREAX , SDLUNAME, STRTDATE,STRTTIME FROM TBTCO where STATUS='R' ORDER BY STRTDATE""",**{'async':0},timeout=30 )
            del a['lines']['item'][0]
            del a['lines']['item'][-1]
            del a['lines']['item'][-1]
            for i in a['lines']['item']:
                job = i.split(",")
                sapjobsuniqueid = uuid.uuid4()
                sql = "INSERT INTO sapjobs(sapjobsuniqueid,customer_id,system_id,jobtype,jobname,btcsysreax,sdluname,startdate,starttime,created_at,sub_by,log_id) VALUES(%s, %s,%s, %s,%s, %s,%s, %s,%s, %s,%s, %s)"
                sql_value = (
                    sapjobsuniqueid.hex,
                    cusid,
                    sysid,
                    'Active Jobs',
                    job[0],
                    job[1],
                    job[2],
                    job[3],
                    job[4],
                    created_at,
                    sub_by,
                    log_id
                    )
                mycursor.execute(sql, sql_value)
                mydb.commit()
        except:
            message = "Failed"
        try:
            #a1 = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""SELECT top 10 JOBNAME,BTCSYSREAX , SDLUNAME, STRTDATE, STRTTIME FROM TBTCO where STATUS='F' and STRTDATE=(to_char(CURRENT_DATE,'YYYYMMDD')) ORDER BY JOBNAME""",**{'async':0},timeout=30 )
            a1 = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""SELECT JOBNAME,BTCSYSREAX , SDLUNAME, STRTDATE, STRTTIME FROM TBTCO where STATUS='A' and STRTDATE=to_char(CURRENT_DATE,'YYYYMMDD') ORDER BY JOBNAME""",**{'async':0},timeout=30 )
            del a1['lines']['item'][0]
            del a1['lines']['item'][-1]
            del a1['lines']['item'][-1]
            for i in a1['lines']['item']:
                job = i.split(",")
                sapjobsuniqueid = uuid.uuid4()
                sql = "INSERT INTO sapjobs(sapjobsuniqueid,customer_id,system_id,jobtype,jobname,btcsysreax,sdluname,startdate,starttime,created_at,sub_by,log_id) VALUES(%s, %s,%s, %s,%s, %s,%s, %s,%s, %s,%s, %s)"
                sql_value = (
                    sapjobsuniqueid.hex,
                    cusid,
                    sysid,
                    'Cancelled Jobs',
                    job[0],
                    job[1],
                    job[2],
                    job[3],
                    job[4],
                    created_at,
                    sub_by,
                    log_id
                    )
                mycursor.execute(sql, sql_value)
                mydb.commit()
        except Exception as err:
            f = open("/var/www/html/caremigration/careapi/sapjbos.txt", "w")
            f.write(str(err))
            f.close()

def hanabackuplogs(i):
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        sysid = i["system_id"]
        cusid = i["customer_id"]
        sub_by = "auto_monitoring"
        sid = i["ssid"]
        log_id = uuid.uuid4().hex
        created_at = datetime.datetime.now()
        try:
            if i["ostype"] == 'Linux':
                a = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""select top 10 SYS_START_TIME,STATE_NAME from SYS.M_BACKUP_CATALOG where ENTRY_TYPE_NAME='complete data backup' order by SYS_START_TIME DESC""",**{'async':0},timeout=30 )
            elif i["ostype"] == 'Microsoft_Windows_Server':
                a = client.service.OSExecute(command= "hdbsql -U DEFAULT ""select top 10 SYS_START_TIME,STATE_NAME from SYS.M_BACKUP_CATALOG where ENTRY_TYPE_NAME='complete data backup' order by SYS_START_TIME DESC""",**{'async':0},timeout=30 )
            
            del a['lines']['item'][0]
            del a['lines']['item'][-1]
            del a['lines']['item'][-1]
            for j in a['lines']['item']:
                job = j.split(",")
                dbbackupuniqueid = uuid.uuid4()
                sql = "INSERT INTO dbbackup(dbbackupuniqueid,customer_id,system_id,snapshottime,dbsize,dbcapacity,created_at,sub_by,log_id) VALUES(%s,%s,%s,%s,%s,%s,%s,%s,%s)"
                sql_value = (
                    dbbackupuniqueid.hex,
                    cusid,
                    sysid,
                    job[0],
                    job[1],
                    'DataBackup',
                    created_at,
                    sub_by,
                    log_id
                    )
                mycursor.execute(sql, sql_value)
                mydb.commit()
        except Exception as err:
            pass
        try:
            #a1 = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""SELECT top 10 JOBNAME,BTCSYSREAX , SDLUNAME, STRTDATE, STRTTIME FROM TBTCO where STATUS='F' and STRTDATE=(to_char(CURRENT_DATE,'YYYYMMDD')) ORDER BY JOBNAME""",**{'async':0},timeout=30 )
            if i["ostype"] == 'Linux':
                a1 = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""select top 10 SYS_START_TIME,STATE_NAME from SYS.M_BACKUP_CATALOG where ENTRY_TYPE_NAME='log backup' order by SYS_START_TIME desc""",**{'async':0},timeout=30 )
            elif i["ostype"] == 'Microsoft_Windows_Server':
                a1 = client.service.OSExecute(command= "hdbsql -U DEFAULT ""select top 10 SYS_START_TIME,STATE_NAME from SYS.M_BACKUP_CATALOG where ENTRY_TYPE_NAME='log backup' order by SYS_START_TIME desc""",**{'async':0},timeout=30 )
            del a1['lines']['item'][0]
            del a1['lines']['item'][-1]
            del a1['lines']['item'][-1]
            for j in a1['lines']['item']:
                job = j.split(",")
                dbbackupuniqueid = uuid.uuid4()
                sql = "INSERT INTO dbbackup(dbbackupuniqueid,customer_id,system_id,snapshottime,dbsize,dbcapacity,created_at,sub_by,log_id) VALUES(%s,%s,%s,%s,%s,%s,%s,%s,%s)"
                sql_value = (
                    dbbackupuniqueid.hex,
                    cusid,
                    sysid,
                    job[0],
                    job[1],
                    'Logbackup',
                    created_at,
                    sub_by,
                    log_id
                    )
                mycursor.execute(sql, sql_value)
                mydb.commit()
        except:
            pass

def hanareplication(i):
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        sysid = i["system_id"]
        cusid = i["customer_id"]
        sub_by = "auto_monitoring"
        sid = i["ssid"]
        log_id = uuid.uuid4().hex
        created_at = datetime.datetime.now()
        try:
            if i["ostype"] == 'Linux':
                a = client.service.OSExecute(command= "/usr/sap/"+ sid + "/hdbclient/hdbsql -U DEFAULT ""select host, SECONDARY_HOST, PORT, SITE_NAME, SECONDARY_SITE_NAME, REPLICATION_MODE, REPLICATION_STATUS, REPLICATION_STATUS_DETAILS,SECONDARY_ACTIVE_STATUS from M_SERVICE_REPLICATION;""",**{'async':0},timeout=30 )
            elif i["ostype"] == 'Microsoft_Windows_Server':
                a = client.service.OSExecute(command= "hdbsql -U DEFAULT ""select host, SECONDARY_HOST, PORT, SITE_NAME, SECONDARY_SITE_NAME, REPLICATION_MODE, REPLICATION_STATUS, REPLICATION_STATUS_DETAILS,SECONDARY_ACTIVE_STATUS from M_SERVICE_REPLICATION;""",**{'async':0},timeout=30 )
            rows = a['lines']['item'][-1]
            rows = rows.split(' ')
            if (int(rows[0]) > 0):
                f = open("/var/www/html/caremigration/careapi/replication.txt", "w")
                f.write(str(a))
                f.close()
        except Exception as err:
            pass

def ABAPReadSyslog(i):
    client = Connection(i["wsdl"],i["sid"],i['pwd'])
    logfile = client.service.ListLogFiles()
    sysid = i["system_id"]
    cusid = i["customer_id"]
    created_at = datetime.datetime.now()
    sub_by = "auto_monitoring"
    aluniqueid = uuid.uuid4().hex
    log_id = uuid.uuid4().hex
    d = datetime.datetime.now() - timedelta(hours=1)
    logfilter = 'Time>'+d.strftime('%Y %m %d %H:%M:%S')+'#Type#Client#MNo#Tcode#User#Severity=Error#Text'
    for i in logfile:
        if (i['format'] == 'SAP Syslog'):
            a = client.service.ReadLogFile(filename=i['filename'],filter=logfilter,maxentries=0)
            for j in a["fields"]["item"]:
                my_str = j.split('\t')
                sql = "INSERT INTO abaplogs(abaplogsuniqueid,customer_id,system_id,Time,Typ,Client,User,Tcode,MNo,Text,Severity,created_at,sub_by,log_id) VALUES(%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s)"
                sql_value = (
                    aluniqueid,
                    cusid,
                    sysid,
                    j[1],
                    j[2],
                    j[3],
                    j[4],
                    j[5],
                    j[6],
                    str(j),
                    j[0],
                    created_at,
                    sub_by,
                    log_id
                    )
            mycursor.execute(sql, sql_value)
            mydb.commit()


def CallFromExternal(instance_id):
    instw = instWSDL(instance_id)
    instw_abap = []
    instw_enque = []
    instw_j2ee = []
    list_trees = currentalerts_generic(instw)
    fs(list_trees)
    cpu(list_trees)
    mem(list_trees)
    getprocesslist(instw)
    currentalerts(instw)
    heartbeat(instw)
    instanceheartbeat(instw)
    s = instw["features"].split("|")
    if "ABAP" in s:
        workprocess(instw)
        list_trees_abap = list_trees
        buffer(list_trees_abap)
        runtimedumps(list_trees_abap)
        responsetime(list_trees_abap)
        update(list_trees_abap)
        R3trans_check(instw)
        ABAPReadSyslog(instw)
        if instw["dbtype"] == "hdb":
            sapjobs(instw)
            hanabackuplogs(instw)
            hanareplication(instw)

    elif "ENQUE" in s:
        enquelocks(instw)
    elif "J2EE" in s:
        R3trans_check(instw)
        J2EEGetProcessList2(instw)
        J2EEGetThreadList2(instw)
        J2EEGetSessionList(instw)
        J2EEGetWebSessionList(instw)
        J2EEGetCacheStatistic2(instw)
        J2EEGetComponentList(instw)
        J2EEGetVMHeapInfo(instw)
        J2EEGetVMGCHistory2(instw)
        J2EEGetSharedTableInfo(instw)

